require 'sketchup'

# snaps selection to the current unit in Model Info - Units - Enable Length Snapping

class DS_Snap_To_Unit

		def self.fixup_selection_transforms()
			snapLength = Sketchup.active_model.options['UnitsOptions']['LengthSnapLength']
			Sketchup.active_model.selection.each { |s|
				if(s.class == Sketchup::ComponentInstance)
					ta = s.transformation.to_a
					xDiff = ta[12] % snapLength
					yDiff = ta[13] % snapLength
					zDiff = ta[14] % snapLength
					(xDiff < (snapLength / 2)) ? ta[12] = ta[12] - xDiff : ta[12] = ta[12] + (snapLength - xDiff)
					(yDiff < (snapLength / 2)) ? ta[13] = ta[13] - yDiff : ta[13] = ta[13] + (snapLength - yDiff)
					(zDiff < (snapLength / 2)) ? ta[14] = ta[14] - zDiff : ta[14] = ta[14] + (snapLength - zDiff)
					t = Geom::Transformation.new ta
					s.transformation = t
				end
			}
		end



end #class

unless( file_loaded?(__FILE__))
  UI.menu("Plugins").add_item("Snap 2 Unit") { DS_Snap_To_Unit.fixup_selection_transforms() }
end
